



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用Lucene.net+盘古分词实现搜索查询</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用Lucene.net+盘古分词实现搜索查询</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 03:54:36 </span>
						</div>
										<div class="post-content">
											
		<p>这里我的的Demo的逻辑是这样的：首先我基本的数据是储存在Sql数据库中，然后我把我的必需的数据推送到MongoDB中，这样再去利用Lucene.net+盘古创建索引；其中为什么要这样把数据推送到MongoDb中，我的理解是可以从Sql中直接取出来必需的数据，首次推送可能是要推送所有的数据，直接创建索引，但是在第二次推送的时候，可能存在要修改或者新增的数据，这样我们就需要一个中间表，而这个中间表我们是使用的MongoDB文件型存储来处理啦，而没在sql数据库中在建立一张表，我是这么理解的。。。大体上的逻辑是这样的，下面简单写一个实现的逻辑。</p>
<p>细微的说下程序的逻辑如下：</p>
<p>1、第一次推数据，把所有的数据推送到mongo，而且第一次搜索的话只能在元数据的list上取数据建立索引<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2、第二次推数据：首先对比mongo，如果mongo里面有要新增或者修改的数据，更新mongo，然后再推送lucene中</p>
<p>查询数据：1、如果查询出来的list为空，则从第三方查询，分别有2个链接，如果为空则为空，如果不为空，则查询出来的数据存放在MongoDB，推送Lucene.net中即可。</p>
<p><strong>一、准备工作</strong></p>
<p>首先我这里创建了一个控制台程序，然后引用在NuGet包中添加如下需要安装的dll，如下：</p>
<p><em>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/688593/201707/688593-20170721140746208-1553553195.png" />&nbsp;<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/688593/201707/688593-20170721140826255-1702304178.png" /></em></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/688593/201707/688593-20170721140936380-757747092.png" /></p>
<p><strong>二、Demo结构如下：&nbsp;</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/688593/201707/688593-20170721141102708-947340242.png" /></p>
<p><strong>三、代码如下：</strong></p>
<p>1、Helper文件夹下的BizLogger如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using NLog;<br />
using System;

namespace LuceneNetTest<br />
{<br />
    /// &lt;summary&gt;<br />
    /// 业务日志记录器<br />
    /// &lt;/summary&gt;<br />
    public class BizLogger<br />
    {<br />
        protected Logger _Logger { get; set; }

        public static BizLogger Default { get; protected set; }

        protected BizLogger(Logger logger)<br />
        {<br />
            this._Logger = logger;<br />
        }

        public BizLogger(string name) : this(LogManager.GetLogger(name)) { }

        /// &lt;summary&gt;<br />
        /// 静态构造函数<br />
        /// &lt;/summary&gt;<br />
        static BizLogger()<br />
        {<br />
            Default = new BizLogger(LogManager.GetCurrentClassLogger());<br />
        }

        public void Debug(string message, params object[] args)<br />
        {<br />
            this._Logger.Debug(this.getMessage(message), args);<br />
        }

        public void Info(string message, params object[] args)<br />
        {<br />
            this._Logger.Info(this.getMessage(message), args);<br />
        }

        public void Trace(string message, params object[] args)<br />
        {<br />
            this._Logger.Trace(this.getMessage(message), args);<br />
        }

        public void Error(string message, params object[] args)<br />
        {<br />
            this._Logger.Error(this.getMessage(message), args);<br />
        }

        public void Fatal(string message, params object[] args)<br />
        {<br />
            this._Logger.Fatal(this.getMessage(message), args);<br />
        }

        public void Debug(Exception exception, string message, params object[] args)<br />
        {<br />
            this._Logger.Log(LogLevel.Debug, exception, this.getMessage(message), args);<br />
        }

        public void Info(Exception exception, string message, params object[] args)<br />
        {<br />
            this._Logger.Log(LogLevel.Info, exception, this.getMessage(message), args);<br />
        }

        public void Trace(Exception exception, string message, params object[] args)<br />
        {<br />
            this._Logger.Log(LogLevel.Trace, exception, this.getMessage(message), args);<br />
        }

        public void Error(Exception exception, string message, params object[] args)<br />
        {<br />
            this._Logger.Log(LogLevel.Error, exception, this.getMessage(message), args);<br />
        }

        public void Fatal(Exception exception, string message, params object[] args)<br />
        {<br />
            this._Logger.Log(LogLevel.Fatal, exception, this.getMessage(message), args);<br />
        }

        protected virtual string getMessage(string message)<br />
        {<br />
            return message;<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>2、Helper文件夹下的DataSerializer如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using Newtonsoft.Json;<br />
using Newtonsoft.Json.Serialization;<br />
using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Reflection;<br />
using System.Text;<br />
using System.Threading.Tasks;

namespace LuceneNetTest<br />
{<br />
    /// &lt;summary&gt;<br />
    /// 数据序列化器<br />
    /// &lt;/summary&gt;<br />
    public static class DataSerializer<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// json 序列号<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="source"&gt;要序列化的对象&lt;/param&gt;<br />
        /// &lt;param name="b"&gt;是否忽略空值,true为不忽略&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static string SerizlizeToJSON(object source, bool b = true)<br />
        {<br />
            var setting = new JsonSerializerSettings();<br />
            setting.ContractResolver = new SortedContractResolver();<br />
            if (!b)<br />
            {<br />
                setting.NullValueHandling = NullValueHandling.Ignore; //忽略空对象<br />
            }<br />
            var jsonString = JsonConvert.SerializeObject(source, setting);

            return jsonString;<br />
        }

        public static TData DeserializeFromJSON&lt;TData&gt;(string jsonString)<br />
        {<br />
            var data = JsonConvert.DeserializeObject&lt;TData&gt;(jsonString);<br />
            return data;<br />
        }<br />
    }

    public class SortedContractResolver : DefaultContractResolver<br />
    {<br />
        protected override List&lt;MemberInfo&gt; GetSerializableMembers(Type objectType)<br />
        {<br />
            var members = base.GetSerializableMembers(objectType);

            return members.OrderBy(m =&gt; m.Name).ToList();<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>3、Helper文件夹下的LuceneNetTestHelpers如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.Net;<br />
using System.IO;<br />
using LuceneNetTest.Models;

namespace LuceneNetTest.Helpers<br />
{<br />
    /// &lt;summary&gt;<br />
    /// 数据处理<br />
    /// &lt;/summary&gt;<br />
    public static class LuceneNetTestHelpers<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// 从sql数据库中获取所有的数据，推送到mongodb中<br />
        /// &lt;/summary&gt;<br />
        /// &lt;returns&gt;所有的数据list&lt;/returns&gt;<br />
        public static List&lt;LuceneTestData&gt; GetSqlData()<br />
        {<br />
            #region 第一次推送数据到mogodb

            List&lt;LuceneTestData&gt; invList = new List&lt;LuceneTestData&gt;();//创建索引的集合<br />
            return invList;

            #endregion<br />
        }

        /// &lt;summary&gt;<br />
        /// mongodb数据库中的数据和新查询出来的数据进项对比，<br />
        /// 如果有需要修改和需要新增的数据及修改mongodb，<br />
        /// 这里为lucene创建索引奠定基础（state的状态为y即为新增，n表示修改）<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="invList"&gt;查询出来的sql数据&lt;/param&gt;<br />
        public static string GetMongoDBData(List&lt;LuceneTestData&gt; invList)<br />
        {<br />
            var result = string.Empty;<br />
            MongoDbHelper&lt;LuceneTestData&gt; mgTwo = new MongoDbHelper&lt;LuceneTestData&gt;();<br />
            var exsitList = mgTwo.QueryAll();//取出来mongodb中的数据

            #region 第二次以后推送数据<br />
            try<br />
            {<br />
                foreach (var inv in invList)//遍历元数据库<br />
                {<br />
                    //如果存在就对比是否一样，不一样的话更新mongodb<br />
                    if (exsitList.Any(n =&gt; n.Id == inv.Id))<br />
                    {<br />
                        var oldInvoice = exsitList.FirstOrDefault(n =&gt; n.Id == inv.Id);<br />
                        if (oldInvoice.Name != inv.Name || oldInvoice.Code != inv.Code || oldInvoice.AddressPhone != inv.AddressPhone || oldInvoice.BankAccount != inv.BankAccount)<br />
                        {<br />
                            oldInvoice.Name = inv.Name;<br />
                            oldInvoice.Code = inv.Code;<br />
                            oldInvoice.AddressPhone = inv.AddressPhone;<br />
                            oldInvoice.BankAccount = inv.BankAccount;<br />
                            oldInvoice.State = "n";<br />
                            inv.CreateTime = DateTime.Now.ToString();<br />
                            inv.UpdateTime = "";

                            mgTwo.Update(oldInvoice);<br />
                        }<br />
                    }<br />
                    else<br />
                    {<br />
                        var newInvoice = new LuceneTestData();<br />
                        newInvoice.Name = inv.Name;<br />
                        newInvoice.Code = inv.Code;<br />
                        newInvoice.AddressPhone = inv.AddressPhone;<br />
                        newInvoice.BankAccount = inv.BankAccount;<br />
                        newInvoice.State = "y";<br />
                        newInvoice.CreateTime = DateTime.Now.ToString();<br />
                        newInvoice.UpdateTime = "";<br />
                        mgTwo.InsertOne(newInvoice);//如果不存在就直接插入操作<br />
                    }<br />
                }<br />
                return "";<br />
            }<br />
            catch(Exception ex)<br />
            {<br />
                return ex.Message;<br />
            }

            #endregion

        }

        /// &lt;summary&gt;<br />
        /// 请求第三方数据<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="name"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static string RequestData(string name)<br />
        {<br />
            byte[] bufferStr = System.Text.Encoding.Default.GetBytes(name);<br />
            //api的url<br />
            StringBuilder InvoiceRequestUrl = new StringBuilder();<br />
            InvoiceRequestUrl.Append("。。。。。。。。。。。。。。");<br />
            InvoiceRequestUrl.Append(name);<br />
            InvoiceRequestUrl.Append("。。。。。。。。。。。");<br />
            string strResult = PostReauest(bufferStr, InvoiceRequestUrl.ToString());<br />
            return strResult;<br />
        }

        /// &lt;summary&gt;<br />
        /// 请求第三方数据<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="name"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static string RequestData2(string name)<br />
        {<br />
            byte[] bufferStr = System.Text.Encoding.Default.GetBytes(name);<br />
            //api的url<br />
            StringBuilder InvoiceRequestUrl = new StringBuilder();<br />
            InvoiceRequestUrl.Append("。。。。。。。。。。。。。。。。。。");<br />
            InvoiceRequestUrl.Append(name);<br />
            InvoiceRequestUrl.Append("。。。。。。。。。。。。。。。。");<br />
            string strResult = PostReauest(bufferStr, InvoiceRequestUrl.ToString());<br />
            return strResult;<br />
        }

        /// &lt;summary&gt;<br />
        /// 请求第三方获取搜索结果<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="buffer"&gt;&lt;/param&gt;<br />
        /// &lt;param name="requestUri"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static string PostReauest(byte[] buffer, string requestUri)<br />
        {<br />
            //请求远程HTTP<br />
            string strResult = "";<br />
            Encoding code = Encoding.GetEncoding("utf-8");<br />
            try<br />
            {<br />
                //设置HttpWebRequest基本信息<br />
                HttpWebRequest myReq = (HttpWebRequest)HttpWebRequest.Create(requestUri);<br />
                myReq.Method = "post";<br />
                myReq.ContentType = "application / json";

                //填充POST数据<br />
                myReq.ContentLength = buffer.Length;<br />
                Stream requestStream = myReq.GetRequestStream();<br />
                requestStream.Write(buffer, , buffer.Length);<br />
                requestStream.Close();

                //发送POST数据请求服务器<br />
                HttpWebResponse HttpWResp = (HttpWebResponse)myReq.GetResponse();<br />
                Stream myStream = HttpWResp.GetResponseStream();

                //获取服务器返回信息<br />
                StreamReader reader = new StreamReader(myStream, code);<br />
                StringBuilder responseData = new StringBuilder();<br />
                String line;<br />
                while ((line = reader.ReadLine()) != null)<br />
                {<br />
                    responseData.Append(line);<br />
                }

                //释放<br />
                myStream.Close();

                strResult = responseData.ToString();<br />
            }<br />
            catch (Exception exp)<br />
            {<br />
                strResult = "报错：" + exp.Message;<br />
            }<br />
            return strResult;<br />
        }

        /// &lt;summary&gt;<br />
        /// 第三方结果添加到mongodb中<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="thirdInvoice"&gt;需要添加的第三数据&lt;/param&gt;<br />
        /// &lt;param name="path"&gt;创建索引 &lt;/param&gt;<br />
        /// &lt;param name="IndexDic"&gt;&lt;/param&gt;<br />
        public static void InThirdInfoToMongoAndLucene(List&lt;ThirdInfo&gt; thirdInvoice,string path,string IndexDic)<br />
        {<br />
            List&lt;LuceneTestData&gt; invList = new List&lt;LuceneTestData&gt;();<br />
            foreach (var item in thirdInvoice)<br />
            {<br />
                var newInvoice = new LuceneTestData();<br />
                newInvoice.Name = item.Name;<br />
                newInvoice.State = "y";<br />
                newInvoice.CreateTime = DateTime.Now.ToString();<br />
                newInvoice.UpdateTime = "";<br />
                invList.Add(newInvoice);<br />
            }<br />
            MongoDbHelper&lt;LuceneTestData&gt; mg = new MongoDbHelper&lt;LuceneTestData&gt;();<br />
            mg.InsertBatch(invList);<br />
            PanGuLuceneHelper.InitPanGuXmlPath(path);<br />
            PanGuLuceneHelper.CreateIndex(IndexDic, invList);//创建索引<br />
        }

        /// &lt;summary&gt;<br />
        /// 第三方结果添加到mongodb中<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="thirdInvoice"&gt;需要添加的第三数据&lt;/param&gt;<br />
        /// &lt;param name="path"&gt;创建索引 &lt;/param&gt;<br />
        /// &lt;param name="IndexDic"&gt;&lt;/param&gt;<br />
        public static void InThirdTestInfoToMongoAndLucene(List&lt;ThirdTestInfo&gt; elephantHuiYun, string path, string IndexDic)<br />
        {<br />
            List&lt;LuceneTestData&gt; invList = new List&lt;LuceneTestData&gt;();<br />
            foreach (var item in elephantHuiYun)<br />
            {<br />
                var newInvoice = new LuceneTestData();<br />
                newInvoice.Name = item.Nsrmc;<br />
                newInvoice.State = "y";<br />
                newInvoice.CreateTime = DateTime.Now.ToString();<br />
                newInvoice.UpdateTime = "";<br />
                invList.Add(newInvoice);<br />
            }<br />
            MongoDbHelper&lt;LuceneTestData&gt; mg = new MongoDbHelper&lt;LuceneTestData&gt;();<br />
            mg.InsertBatch(invList);<br />
            PanGuLuceneHelper.InitPanGuXmlPath(path);<br />
            PanGuLuceneHelper.CreateIndex(IndexDic, invList);//创建索引<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>4、Helper文件夹下的MongoDbHelper如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using MongoDB.Bson;<br />
using MongoDB.Driver;<br />
using System.Linq.Expressions;<br />
using System.Security.Authentication;

namespace LuceneNetTest.Helpers<br />
{<br />
    /// &lt;summary&gt;<br />
    /// MongoDb帮助类<br />
    /// &lt;/summary&gt;<br />
    public class DB<br />
    {<br />
        private static readonly string connStr = "mongodb://192.168.4.192:27017";<br />
        private static readonly string dbName = "LuceneTestData";

        private static IMongoDatabase db = null;

        private static readonly object lockHelper = new object();

        private DB() { }

        public static IMongoDatabase GetDb()<br />
        {<br />
            if (db == null)<br />
            {<br />
                lock (lockHelper)<br />
                {<br />
                    if (db == null)<br />
                    {<br />
                        MongoClientSettings settings = MongoClientSettings.FromUrl(<br />
                          new MongoUrl(connStr)<br />
                        );<br />
                        settings.SslSettings =<br />
                          new SslSettings() { EnabledSslProtocols = SslProtocols.Tls12 };<br />
                        var mongoClient = new MongoClient(settings);<br />
                        db = mongoClient.GetDatabase(dbName);<br />
                    }<br />
                }<br />
            }<br />
            return db;<br />
        }<br />
    }

    public class MongoDbHelper&lt;T&gt; where T : BaseEntity<br />
    {<br />
        private IMongoDatabase db = null;

        private IMongoCollection&lt;T&gt; collection = null;

        public MongoDbHelper()<br />
        {<br />
            this.db = DB.GetDb();<br />
            collection = db.GetCollection&lt;T&gt;(typeof(T).Name);<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 新增,异步<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="entity"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public T Insert(T entity)<br />
        {<br />
            var flag = ObjectId.GenerateNewId();<br />
            entity.GetType().GetProperty("Id").SetValue(entity, flag);<br />
            entity.State = "y";<br />
            entity.CreateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");<br />
            entity.UpdateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");

            collection.InsertOne(entity);

            return entity;<br />
        }

        /// &lt;summary&gt;<br />
        /// 新增数据,同步<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="entity"&gt;待存储类对象&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public T InsertOne(T entity)<br />
        {<br />
            var flag = ObjectId.GenerateNewId();<br />
            entity.GetType().GetProperty("Id").SetValue(entity, flag);<br />
            entity.State = "y";<br />
            entity.CreateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");<br />
            entity.UpdateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");

            collection.InsertOne(entity);

            return entity;<br />
        }

        /// &lt;summary&gt;<br />
        /// 修改<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="id"&gt;&lt;/param&gt;<br />
        /// &lt;param name="field"&gt;&lt;/param&gt;<br />
        /// &lt;param name="value"&gt;&lt;/param&gt;<br />
        public void Modify(string id, string field, string value)<br />
        {<br />
            var filter = Builders&lt;T&gt;.Filter.Eq("Id", ObjectId.Parse(id));<br />
            var updated = Builders&lt;T&gt;.Update.Set(field, value);<br />
            UpdateResult result = collection.UpdateOne(filter, updated);<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 更新<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="entity"&gt;&lt;/param&gt;<br />
        public void Update(T entity)<br />
        {<br />
            try<br />
            {<br />
                var old = collection.Find(e =&gt; e.Id.Equals(entity.Id)).ToList().FirstOrDefault();

                foreach (var prop in entity.GetType().GetProperties())<br />
                {<br />
                    var newValue = prop.GetValue(entity);<br />
                    var oldValue = old.GetType().GetProperty(prop.Name).GetValue(old);<br />
                    if (newValue != null)<br />
                    {<br />
                        if (oldValue == null)<br />
                            oldValue = "";<br />
                        if (!newValue.ToString().Equals(oldValue.ToString()))<br />
                        {<br />
                            old.GetType().GetProperty(prop.Name).SetValue(old, newValue.ToString());<br />
                        }<br />
                    }<br />
                }<br />
                old.State = "n";<br />
                old.UpdateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");

                var filter = Builders&lt;T&gt;.Filter.Eq("Id", entity.Id);<br />
                ReplaceOneResult result = collection.ReplaceOne(filter, old);<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                var aaa = ex.Message + ex.StackTrace;<br />
                throw ex;<br />
            }<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 更新<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="entity"&gt;&lt;/param&gt;<br />
        public void UpdateEx(T entity)<br />
        {<br />
            try<br />
            {<br />
                var old = collection.Find(e =&gt; e.Id.Equals(entity.Id)).ToList().FirstOrDefault();

                foreach (var prop in entity.GetType().GetProperties())<br />
                {<br />
                    var newValue = prop.GetValue(entity);<br />
                    var oldValue = old.GetType().GetProperty(prop.Name).GetValue(old);<br />
                    if (newValue != null)<br />
                    {<br />
                        if (oldValue == null)<br />
                            oldValue = "";<br />
                        if (!newValue.ToString().Equals(oldValue.ToString()))<br />
                        {<br />
                            old.GetType().GetProperty(prop.Name).SetValue(old, newValue);<br />
                        }<br />
                    }<br />
                }<br />
                old.State = "n";<br />
                old.UpdateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");

                var filter = Builders&lt;T&gt;.Filter.Eq("Id", entity.Id);<br />
                ReplaceOneResult result = collection.ReplaceOne(filter, old);<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                var aaa = ex.Message + ex.StackTrace;<br />
                throw ex;<br />
            }<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 删除,异步<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="entity"&gt;删除对象&lt;/param&gt;<br />
        public void Delete(T entity)<br />
        {<br />
            var filter = Builders&lt;T&gt;.Filter.Eq("Id", entity.Id);<br />
            collection.DeleteOne(filter);<br />
        }

        /// &lt;summary&gt;<br />
        /// 删除,同步<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="Id"&gt;删除对象Id&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public long Delete(string IdString)<br />
        {<br />
            ObjectId Id = ObjectId.Parse(IdString);

            var filter = Builders&lt;T&gt;.Filter.Eq("Id", Id);<br />
            var rt = collection.DeleteOne(filter);<br />
            return rt.DeletedCount;<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 根据id查询一条数据<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="id"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public T QueryOne(string id)<br />
        {<br />
            return collection.Find(a =&gt; a.Id == ObjectId.Parse(id)).ToList().FirstOrDefault();<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 查询所有数据<br />
        /// &lt;/summary&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public List&lt;T&gt; QueryAll()<br />
        {<br />
            return collection.Find(a =&gt; a.State != "").ToList();<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 根据条件查询一条数据<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="express"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public T QueryByFirst(Expression&lt;Func&lt;T, bool&gt;&gt; express)<br />
        {<br />
            return collection.Find(express).ToList().FirstOrDefault();<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 根据条件查询数据<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="express"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public List&lt;T&gt; QueryBy(Expression&lt;Func&lt;T, bool&gt;&gt; express)<br />
        {<br />
            return collection.Find(express).ToList();<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 批量添加<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="list"&gt;&lt;/param&gt;<br />
        public void InsertBatch(List&lt;T&gt; list)<br />
        {<br />
            collection.InsertMany(list);<br />
        }<br />
        /// &lt;summary&gt;<br />
        /// 根据Id批量删除<br />
        /// &lt;/summary&gt;<br />
        public void DeleteBatch(List&lt;ObjectId&gt; list)<br />
        {<br />
            var filter = Builders&lt;T&gt;.Filter.In("Id", list);<br />
            collection.DeleteMany(filter);<br />
        }

        /// &lt;summary&gt;<br />
        /// 未添加到索引的数据<br />
        /// &lt;/summary&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public List&lt;T&gt; QueryToLucene()<br />
        {<br />
            return collection.Find(a =&gt; a.State.Equals("y") || a.State.Equals("n")).ToList();<br />
        }<br />
    }<br />
    public abstract class BaseEntity<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// 对象存储Id,数据库赋值<br />
        /// &lt;/summary&gt;<br />
        public ObjectId Id { get; set; }

        /// &lt;summary&gt;<br />
        /// 状态值,可自行决定使用性质<br />
        /// &lt;/summary&gt;<br />
        public string State { get; set; }

        /// &lt;summary&gt;<br />
        /// 创建时间<br />
        /// &lt;/summary&gt;<br />
        public string CreateTime { get; set; }

        /// &lt;summary&gt;<br />
        /// 修改时间<br />
        /// &lt;/summary&gt;<br />
        public string UpdateTime { get; set; }<br />
    }<br />
}</pre>
</div>
</div>
<p>5、Models文件夹下的LuceneTestData如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using LuceneNetTest.Helpers;

namespace LuceneNetTest.Models<br />
{<br />
    public class LuceneTestData : BaseEntity<br />
    {<br />
        public string Name { get; set; }<br />
        public string Code { get; set; }<br />
        public string AddressPhone { get; set; }<br />
        public string BankAccount { get; set; }<br />
    }<br />
}</pre>
</div>
</div>
<p>6、Models文件夹下的ThirdInfo如下：</p>
<div>
<div>
<pre class="prettyprint linenums">namespace LuceneNetTest.Models<br />
{<br />
    public class ThirdInfo<br />
    {<br />
        public string Id { get; set; }<br />
        public string Name { get; set; }<br />
        public string Taxnum { get; set; }<br />
    }<br />
}</pre>
</div>
</div>
<p>7、Models文件夹下的ThirdTestData用户请求第三方数据反序列化解析数据，暂不展示</p>
<p>8、PanGu文件夹下是盘古分词，这里下载添加即可。</p>
<p>9、PanGuLuceneHelper如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using Lucene.Net.Documents;<br />
using Lucene.Net.Index;<br />
using Lucene.Net.Analysis;<br />
using System.Collections.Generic;<br />
using System.IO;<br />
using Lucene.Net.Search;<br />
using System;<br />
using Lucene.Net.Store;<br />
using Lucene.Net.QueryParsers;<br />
using LuceneNetTest.Models;<br />
using LuceneNetTest.Helpers;<br />
using MongoDB.Bson;

namespace LuceneNetTest<br />
{<br />
    /// &lt;summary&gt;<br />
    /// 信息<br />
    /// &lt;/summary&gt;<br />
    public class PanGuLuceneHelper<br />
    {

        public static Analyzer analyzer = new PanGuAnalyzer();//指定使用盘古 PanGuAnalyzer 分词算法

        /// &lt;summary&gt;<br />
        /// 初始化盘古分词的xml引用路径<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="PanGuXmlPath"&gt;&lt;/param&gt;<br />
        public static void InitPanGuXmlPath(string PanGuXmlPath)<br />
        {<br />
            //定义盘古分词的xml引用路径<br />
            PanGu.Segment.Init(PanGuXmlPath);<br />
        }

        /// &lt;summary&gt;<br />
        /// 创建索引<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="IndexDic"&gt;目录地址&lt;/param&gt;<br />
        /// &lt;param name="isCreate"&gt;是否重新创建&lt;/param&gt;<br />
        public static Result CreateIndex(string IndexDic,List&lt;LuceneTestData&gt; list = null)<br />
        {<br />
            IndexWriter writer;<br />
            var result = new Result();<br />
            try<br />
            {<br />
                //创建索引目录<br />
                FSDirectory directory = FSDirectory.Open(new DirectoryInfo(IndexDic), new NativeFSLockFactory());<br />
                //IndexReader:对索引库进行读取的类<br />
                //是否存在索引库文件夹以及索引库特征文件<br />
                //如果索引目录被锁定（比如索引过程中程序异常退出或另一进程在操作索引库），则解锁<br />
                if (IndexWriter.IsLocked(directory))<br />
                {<br />
                    IndexWriter.Unlock(directory);<br />
                }<br />
                //IndexWriter第三个参数:true指重新创建索引,false指从当前索引追加....此处为新建索引所以为true<br />
                writer = new IndexWriter(directory, analyzer, Lucene.Net.Index.IndexWriter.MaxFieldLength.LIMITED);<br />
                AddIndex(writer, list);<br />
                writer.Optimize();<br />
                writer.Dispose();<br />
                result = new Result()<br />
                {<br />
                    Success = true<br />
                };<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                result = new Result()<br />
                {<br />
                    Success = false,<br />
                    Message = ex.Message<br />
                };<br />
            }<br />
            return result;<br />
        }

        /// &lt;summary&gt;<br />
        /// 创建索引<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="analyzer"&gt;&lt;/param&gt;<br />
        /// &lt;param name="title"&gt;&lt;/param&gt;<br />
        /// &lt;param name="content"&gt;&lt;/param&gt;<br />
        private static void AddIndex(IndexWriter writer, List&lt;LuceneTestData&gt; list = null)<br />
        {<br />
            try<br />
            {<br />
                //for (int i = 0; i &lt; 10; i++)<br />
                //{<br />
                //    Document doc = new Document();<br />
                //    doc.Add(new Field("Name", "大贲科技" + i, Field.Store.YES, Field.Index.ANALYZED));//存储且索引<br />
                //    writer.AddDocument(doc);<br />
                //}<br />
                MongoDbHelper&lt;LuceneTestData&gt; mg = new MongoDbHelper&lt;LuceneTestData&gt;();<br />
                var customerList = mg.QueryToLucene();<br />
                if (list != null)<br />
                {<br />
                    customerList = list;<br />
                }<br />
                foreach (var item in customerList)<br />
                {<br />
                    Document doc = new Document();<br />
                    doc.Add(new Field("Name", item.Name == null ? "" : item.Name, Field.Store.YES, Field.Index.ANALYZED));//存储且索引<br />
                    doc.Add(new Field("TaxCode", item.Code == null ? "" : item.Code, Field.Store.YES, Field.Index.ANALYZED));//存储且索引<br />
                    doc.Add(new Field("AddressPhone", item.AddressPhone == null ? "" : item.AddressPhone, Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("BankAccount", item.BankAccount == null ? "" : item.BankAccount, Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("State", item.State, Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("Id", item.Id.ToString(), Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("CreateTime", item.CreateTime.ToString(), Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("UpdateTime", item.UpdateTime.ToString(), Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引

                    if (item.State == "n")//修改<br />
                    {<br />
                        Term t = new Term("Id", item.Id.ToString());<br />
                        writer.DeleteDocuments(t);<br />
                        writer.AddDocument(doc);<br />
                    }<br />
                    else if (item.State == "y")//新增<br />
                    {<br />
                        writer.AddDocument(doc);<br />
                    }<br />
                    //修改mongodb状态为ok，下次就不操作到索引了。<br />
                    mg.Modify(item.Id.ToString(), "State", "ok");<br />
                }<br />
            }<br />
            catch (FileNotFoundException fnfe)<br />
            {<br />
                throw fnfe;<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                throw ex;<br />
            }<br />
        }

        /// &lt;summary&gt;<br />
        /// 创建索引<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="analyzer"&gt;&lt;/param&gt;<br />
        /// &lt;param name="title"&gt;&lt;/param&gt;<br />
        /// &lt;param name="content"&gt;&lt;/param&gt;<br />
        private static void AddIndexNew(IndexWriter writer)<br />
        {<br />
            try<br />
            {<br />
                MongoDbHelper&lt;LuceneTestData&gt; mg = new MongoDbHelper&lt;LuceneTestData&gt;();<br />
                var customerList = mg.QueryToLucene();<br />
                foreach (var item in customerList)<br />
                {<br />
                    Document doc = new Document();<br />
                    doc.Add(new Field("Name", item.Name == null ? "" : item.Name, Field.Store.YES, Field.Index.ANALYZED));//存储且索引<br />
                    doc.Add(new Field("TaxCode", item.Code == null ? "" : item.Code, Field.Store.YES, Field.Index.ANALYZED));//存储且索引<br />
                    doc.Add(new Field("AddressPhone", item.AddressPhone == null ? "" : item.AddressPhone, Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("BankAccount", item.BankAccount == null ? "" : item.BankAccount, Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("State", item.State, Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("Id", item.Id.ToString(), Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("CreateTime", item.CreateTime.ToString(), Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引<br />
                    doc.Add(new Field("UpdateTime", item.UpdateTime.ToString(), Field.Store.YES, Field.Index.NOT_ANALYZED));//存储且索引

                    if (item.State == "n")//修改<br />
                    {<br />
                        Term t = new Term("Id", item.Id.ToString());<br />
                        writer.DeleteDocuments(t);<br />
                        writer.AddDocument(doc);<br />
                    }<br />
                    else if (item.State == "y")//新增<br />
                    {<br />
                        writer.AddDocument(doc);<br />
                    }<br />
                    //修改mongodb状态为ok，下次就不操作到索引了。<br />
                    mg.Modify(item.Id.ToString(), "State", "ok");<br />
                }<br />
            }<br />
            catch (FileNotFoundException fnfe)<br />
            {<br />
                throw fnfe;<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                throw ex;<br />
            }<br />
        }

        /// &lt;summary&gt;<br />
        /// 分词方法<br />
        /// &lt;/summary&gt;<br />
        /// &lt;param name="words"&gt;待分词内容&lt;/param&gt;<br />
        /// &lt;param name="analyzer"&gt;&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        private static string cutWords(string words, Analyzer analyzer)<br />
        {<br />
            string resultStr = "";<br />
            System.IO.StringReader reader = new System.IO.StringReader(words);<br />
            Lucene.Net.Analysis.TokenStream ts = analyzer.TokenStream(words, reader);<br />
            bool hasNext = ts.IncrementToken();<br />
            Lucene.Net.Analysis.Tokenattributes.ITermAttribute ita;<br />
            while (hasNext)<br />
            {<br />
                ita = ts.GetAttribute&lt;Lucene.Net.Analysis.Tokenattributes.ITermAttribute&gt;();<br />
                resultStr += ita.Term + "|";<br />
                hasNext = ts.IncrementToken();<br />
            }<br />
            ts.CloneAttributes();<br />
            reader.Close();<br />
            analyzer.Close();<br />
            return resultStr;<br />
        }

        /// &lt;summary&gt;<br />
        /// 从索引搜索结果<br />
        /// &lt;/summary&gt;<br />
        public static List&lt;LuceneTestData&gt; SearchIndex(string content, string IndexDic)<br />
        {<br />
            try<br />
            {<br />
                var str = cutWords(content, analyzer);<br />
                FSDirectory directory = FSDirectory.Open(new DirectoryInfo(IndexDic), new NoLockFactory());<br />
                IndexReader reader = IndexReader.Open(directory, true);<br />
                IndexSearcher search = new IndexSearcher(directory, true);

                //创建查询<br />
                PerFieldAnalyzerWrapper wrapper = new PerFieldAnalyzerWrapper(analyzer);<br />
                wrapper.AddAnalyzer("Name", analyzer);<br />
                QueryParser parser = new QueryParser(Lucene.Net.Util.Version.LUCENE_30, "Name", wrapper);<br />
                Query query = parser.Parse(content);<br />
                TopScoreDocCollector collector = TopScoreDocCollector.Create(, true);//10--默认查询4条数

                BooleanQuery bQuery = new BooleanQuery();<br />
                bQuery.Add(query, new Occur());<br />
                search.Search(bQuery, collector);<br />
                var hits = collector.TopDocs().ScoreDocs;

                int numTotalHits = collector.TotalHits;

                List&lt;LuceneTestData&gt; list = new List&lt;LuceneTestData&gt;();<br />
                for (int i = ; i &lt; hits.Length; i++)<br />
                {<br />
                    var hit = hits[i];<br />
                    Document doc = search.Doc(hit.Doc);

                    var model = new LuceneTestData()<br />
                    {<br />
                        Name = doc.Get("Name").ToString(),<br />
                        Code = doc.Get("TaxCode").ToString(),<br />
                        AddressPhone = doc.Get("AddressPhone").ToString(),<br />
                        BankAccount = doc.Get("BankAccount").ToString(),<br />
                        State = doc.Get("State").ToString(),<br />
                        Id = ObjectId.Parse(doc.Get("Id")),<br />
                        CreateTime = doc.Get("CreateTime").ToString(),<br />
                        UpdateTime = doc.Get("UpdateTime").ToString()<br />
                    };<br />
                    list.Add(model);<br />
                }<br />
                return list;<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                throw ex;<br />
            }<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>10、Program如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using LuceneNetTest.Models;<br />
using LuceneNetTest.Helpers;

namespace LuceneNetTest<br />
{<br />
    class Program<br />
    {<br />
        //1、第一次推数据，把所有的数据推送到mongo，而且第一次搜索的话只能在元数据的list上取数据建立索引<br />
        //2、第二次推数据：首先对比mongo，如果mongo里面有要新增或者修改的数据，更新mongo，然后再推送lucene中

        //查询数据：1、如果查询出来的list为空，则从第三方查询，分别有2个链接，如果为空则为空，如果不为空，<br />
        //则查询出来的数据存放在mongo中，推送到lucene中<br />
        static void Main(string[] args)<br />
        {<br />
            var IndexDic = @"C:/Users/Administrator/Desktop/RSA/LuceneNetTest/IndexDic/IndexDic";//索引创建的地址<br />
            var path = @"C:/Users/Administrator/Desktop/RSA/LuceneNetTest/PanGu/PanGu.xml";//盘古分词地址<br />
            List&lt;LuceneTestData&gt; invList = LuceneNetTestHelpers.GetSqlData();<br />
            BizLogger.Default.Info($"初次获取信息数据，总共获取了{invList.Count}条。");

            #region  第一次推送数据到mogodb

            MongoDbHelper&lt;LuceneTestData&gt; mg = new MongoDbHelper&lt;LuceneTestData&gt;();<br />
            mg.InsertBatch(invList);<br />
            BizLogger.Default.Info($"信息数据推送到MongoDB数据库完成，总共获取了{invList.Count}条。");<br />
            PanGuLuceneHelper.InitPanGuXmlPath(path);<br />
            PanGuLuceneHelper.CreateIndex(IndexDic, invList);//创建索引<br />
            BizLogger.Default.Info($"信息数据初次创建索引成功，总共创建了{invList.Count}条数据。");

            #endregion

            #region 第二次推送数据到mogodb

            //取出来本次查询的sql数据与mongodb数据库中的数据是否有差别。。。<br />
            string result = LuceneNetTestHelpers.GetMongoDBData(invList);<br />
            BizLogger.Default.Info($"从SQL数据库获取信息与MongoDB数据信息进行对比，总共获取了{invList.Count}条。");<br />
            //var IndexDic = AppDomain.CurrentDomain.BaseDirectory + "/IndexDic";<br />
            if (string.IsNullOrEmpty(result))<br />
            {<br />
                PanGuLuceneHelper.InitPanGuXmlPath(path);<br />
                PanGuLuceneHelper.CreateIndex(IndexDic);//创建索引<br />
                BizLogger.Default.Info($"信息创建索引成功");<br />
            }

            #endregion

            #region 搜索

            string name = "上海";<br />
            var list = PanGuLuceneHelper.SearchIndex(name, IndexDic);//搜索查询<br />
            if (list == null)<br />
            {<br />
                //第一次请求第三方（诺诺：用的航信的）<br />
                string strResult = LuceneNetTestHelpers.RequestData(name);<br />
                if (!string.IsNullOrEmpty(strResult))<br />
                {<br />
                    List&lt;ThirdInfo&gt; thirdInfo = DataSerializer.DeserializeFromJSON&lt;List&lt;ThirdInfo&gt;&gt;(strResult);<br />
                    //更新mongodb数据库饼更新创建索引<br />
                    LuceneNetTestHelpers.InThirdInfoToMongoAndLucene(thirdInfo, path, IndexDic);<br />
                    BizLogger.Default.Info($"从第三方。。中获取信息更新到MongoDB成功，并且创建索引成功");<br />
                    //反序列化结果<br />
                    Console.WriteLine(string.Join("，", thirdInfo.Select(t =&gt; t.Name)));<br />
                }<br />
                else<br />
                {<br />
                    //第二次请求第三方（大象慧云）<br />
                    string twoResult = LuceneNetTestHelpers.RequestData2(name);<br />
                    if (!string.IsNullOrEmpty(twoResult))<br />
                    {<br />
                        //同上请求第三方<br />
                    }<br />
                    else<br />
                    {<br />
                        Console.WriteLine("暂无信息");<br />
                    }<br />
                }<br />
            }

            #endregion

            Console.WriteLine(string.Join("，", list.Select(n =&gt; n.Name)));<br />
            Console.ReadKey();<br />
        }<br />
    }<br />
}
 </pre>
</div>
</div>
<p>11、Result如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;

namespace LuceneNetTest<br />
{<br />
    public class Result<br />
    {<br />
        public bool Success { get; set; }

        public int StatusCode { get; set; }

        public string Message { get; set; }<br />
    }<br />
}</pre>
</div>
</div>
<p>上面简单的实现了搜索。</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7zw419.html">动态SQL 学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7l0jj8.html">总结Android中遇见的OOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zrmw3q.html">一看便知linux下mysql报错ERROR 1044&colon; Access denied for user&colon; &amp;&num;39&semi;&commat;localhost&amp;&num;39&semi; to database &amp;&num;39&semi;mysql&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p5op48.html">关于学习Knockoutjs--入门（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q24onv8.html">HTTP 错误 503&period;2 - Service Unavailable 正在超过 serverRuntime&commat;appConcurrentRequestLimit 设置的值。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mm00gq.html">Canu Parameter Reference（canu参数介绍）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xyowg9.html">长理ACM 7-密码破译&lpar;闫博钊&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjxdxd9.html">ip协议的数据分片备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1r0gk8.html">Android UI--ViewPager扩展Tab标签指示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1wejmq.html">NProxy&mdash;&mdash;Mac和Linux平台下的Fiddler</a>
		</li>
						<li><a href="https://www.batexi.com/a/9503mpv8.html">C&num; 语言规范&lowbar;版本5&period;0 &lpar;第21章 附录C&lowbar;参考资料&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gep6pl8.html">mongodb 性能提高之利用索引， 待续</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meppx2q.html">JNI只C性能测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mewenoq.html">LinkBar选中项字体颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyv4vz9.html">前端开发之基础知识-HTML（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7odwpk8.html">C&plus;&plus;内存分区：堆、栈、自由存储区、全局&sol;静态存储区和常量存储区</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jw16jq.html">HMM模型学习笔记（维特比算法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jo460q.html">ThreadPoolExecutor最佳实践--如何选择线程数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4lpglq.html">&lbrack;mysql&rsqb; 归档工具pt-archiver，binlog格式由mixed变成row</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp6jm09.html">LeetCode103 BinaryTreeZigzagLevelOrderTraversal&lpar;二叉树Z形层次遍历&rpar;  Java题解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1kl6549.html">nodejs零基础详细教程1：安装&plus;基础概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk53p08.html">js禁止浏览器的回退事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo4wevq.html">Chapter 3&colon;Speech Production and Perception</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd3l4z9.html">io-nio 区别示意图</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yvmmg8.html">eclipse下启动tomcat项目，访问tomcat默认端口显示404错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kl0449.html">删除iPhone图片，提示&OpenCurlyDoubleQuote;没有删除此项目的权限&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yve708.html">有关SQL模糊查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pyxxv8.html">Vue-cli 记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/950w6ev8.html">crontab问题处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpv3jr9.html">HTTP协议 状态码 telnet 笔记分享</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
